// pages/consultation/consultation.js
// 获取全局的应用实例
const app = getApp();

// 引入utils全局函数
var dou = require('../../utils/util.js');

Page({
  data: {
    textAreaMaxLen: 200,
    inputValueLength: 0,
  },
 
  onShow: function(options) {
    var that = this

    // 判断是否登录
    dou.checkLoginState()
  },
 
  onLoad: function(options) {
    var that = this
        
    wx.setNavigationBarTitle({
      title: app.title.consultation
    })

    // 显示转发按钮
    dou.showShareMenu()

    wx.request({
      url: app.mp_url + 'databox.php?rec=common',
      success: function(res) {
        that.setData({
          lang: res.data.lang,
          site: res.data.site
        })
      },
    })
  },
 
  consultationAdd: function (e) {
    var that = this
    
    // 未登录时重新载入当前页面
    dou.checkLoginState('action', '/pages/user/user')
   
    wx.request({
      url: app.mp_url + 'consultation.php?rec=insert',
      data: {
        user_id: wx.getStorageSync('user_id'),
        shell: wx.getStorageSync('shell'),
        post: JSON.stringify(e.detail.value)
      },
      method:'POST',
      header: {
        'Connect-Key' : wx.getStorageSync('connect_key'),
        'Content-Type': 'application/x-www-form-urlencoded'
      },
      success: function (res) {
        if (res.data.wrong) {
          dou.douMsg(res.data.wrong)
        } else {
          dou.douMsg(that.data.lang.consultation_insert_success)
         
          setTimeout(function () {
            wx.switchTab({
              url: '/pages/index/index'
            })
          }, 2000)
        }
      }
    })
  },
 
  bindKeyInput: function (e) {
    if(e.detail.value.length > 200){
      this.setData({
        inputValueLength:200,
        inputValue: e.detail.value
      })
    }else{
      this.setData({
        inputValueLength:e.detail.value.length,
        inputValue: e.detail.value
      })
    }
  },
 
  bindPickerChange: function (e) {
    this.setData({
      index: e.detail.value
    })
  },

  // 设置转发标题
  onShareAppMessage: function (options) {
    return {
      title: wx.getStorageSync('shareTitle')
    }
  }

})