<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2024 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2024-09-30
 */
define('IN_DOUCO', true);

$_CUR = 'consultation';
require (dirname(__FILE__) . '/include/init.php');

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

// 权限验证
$callback = $dou_user->check_login_state(); // 登录验证
if ($callback['msg'] == 'ok') {
    $user_id = $callback['user_id'];
} else {
    if (!in_array($rec, $nomust_login_array)) {
        $data['wrong'] = $_LANG['login_timeout'];
        die(json_encode($data));
    }
}

// 错误提示初始
$data['wrong'] = '';

/**
 * +----------------------------------------------------------
 * 业务咨询
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    // 数据封装
    $data['title'] = $_LANG['consultation'];
}

/**
 * +----------------------------------------------------------
 * 咨询添加
 * +----------------------------------------------------------
 */
if ($rec == 'insert') {
    // 格式化POST项
    $_POST = array_merge($_POST, get_object_vars(json_decode(str_replace("\\", "", $_REQUEST['post']))));
    
    $ip = $dou->get_ip();
    $add_time = time();
    
    // 如果限制必须输入中文则修改错误提示
    $include_chinese = $_CFG['guestbook_check_chinese'] ? $_LANG['consultation_include_chinese'] : '';
    
    // 验证主题
    if ($check->is_illegal_char($_POST['contact'])) {
        $wrong['contact'] = $_LANG['consultation_contact'] . $_LANG['illegal_char'];
    } elseif (!$check->length($_POST['contact'], 50)) {
        $wrong['contact'] = $_LANG['consultation_contact_wrong'];
    }
    
    // 验证联系人
    if ($check->is_illegal_char($_POST['telphone'])) {
        $wrong['telphone'] = $_LANG['consultation_telphone'] . $_LANG['illegal_char'];
    } elseif (!$check->is_telphone($_POST['telphone'])) {
        $wrong['telphone'] = $_LANG['consultation_telphone'] . $_LANG['is_wrong'];
    }
 
    if ($_POST['all_field']) {
        // 验证邮箱
        if (empty($_POST['email'])) {
            $wrong['email'] = $_LANG['consultation_email'] . $_LANG['is_empty'];
        } elseif (!$check->is_email($_POST['email'])) {
            $wrong['email'] = $_LANG['consultation_email'] . $_LANG['is_wrong'];
        }
     
        if ($_CFG['language'] != 'zh_cn') {
            // 验证country
            if ($check->is_illegal_char($_POST['country'])) {
                $wrong['country'] = $_LANG['consultation_country'] . ' / ' . $_LANG['consultation_province'] . $_LANG['illegal_char'];
            } elseif (empty($_POST['country'])) {
                $wrong['country'] = $_LANG['consultation_country'] . ' / ' . $_LANG['consultation_province'] . $_LANG['is_empty'];
            }
        }
     
        // 验证公司
        if ($check->is_illegal_char($_POST['company']))
            $wrong['company'] = $_LANG['consultation_company'] . $_LANG['illegal_char'];
    }
    
    // 验证咨询内容
    if ($check->is_illegal_char($_POST['brief'])) {
        $wrong['brief'] = $_LANG['consultation_brief'] . $_LANG['illegal_char'];
    } elseif (!$check->length($_POST['brief'], 300)) {
        $wrong['brief'] = $_LANG['consultation_brief_wrong'];
    }
    
    // 检查IP是否频繁咨询
    if (is_water($ip, $user_id)) {
        $wrong['is_water'] = $_LANG['consultation_is_water'];
    }
        
    // 错误提示
    foreach ($wrong as $item) {
        $data['wrong'] = $item;
        die(json_encode($data));
    }

    // 安全处理用户输入信息
    $_POST = $firewall->dou_foreground($_POST);
    
    $sql = "INSERT INTO " . $dou->table('consultation') . " (id, user_id, contact, telphone, email, country, province, company, brief, ip, add_time)" . " VALUES (NULL, '$user_id', '$_POST[contact]', '$_POST[telphone]', '$_POST[email]', '$_POST[country]', '$_POST[province]', '$_POST[company]', '$_POST[brief]', '$ip', '$add_time')";
    $dou->query($sql);
}

echo json_encode($data);

/**
 * +----------------------------------------------------------
 * 防灌水
 * +----------------------------------------------------------
 */
function is_water($ip, $user_id) {
    $unread = $GLOBALS['dou']->get_one("SELECT COUNT(*) FROM " . $GLOBALS['dou']->table('consultation') . " WHERE user_id = '$user_id' AND status = 0");
    
    // 如果管理员未回复的咨询数量大于1
    if ($unread >= 1)
        return true;
}

?>